
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[翻译]自托管WebApi使用OWIN和Unity / 憋错料</title>

    <meta name="description" content="[翻译]自托管WebApi使用OWIN和Unity OWIN托管的WebApi应用程序使用Unity,要比标准的WebApi应用程序使用Unity复杂一点点. 这篇博客展示怎样把ASP.NET Web API寄宿到一个控制台应用程序,使用OWIN自托管WebApi框架和Unity的Ioc. 需要实现下面的步骤: 1.把OWIN.Hosting和Unity的程序集添加到解决方案. 2.Unity的registrations和startup逻辑是必须的. 3.Unity的解析器需要添加到OWIN startup 的上下文. 4.释放资源的逻辑必须实现">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">[翻译]自托管WebApi使用OWIN和Unity</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>OWIN托管的WebApi应用程序使用<a href="https://unity.codeplex.com/" rel="external nofollow noreferrer">Unity</a>,要比标准的WebApi应用程序使用Unity复杂一点点.</p>
<p>这篇博客展示怎样把<a href="http://www.asp.net/web-api" rel="external nofollow noreferrer">ASP.NET Web API</a>寄宿到一个控制台应用程序,使用<a href="http://owin.org/" rel="external nofollow noreferrer">OWIN</a>自托管WebApi框架和Unity的<a href="https://en.wikipedia.org/wiki/Inversion_of_Control" rel="external nofollow noreferrer">Ioc</a>.</p>
<p>需要实现下面的步骤:</p>
<p>　　1.把OWIN.Hosting和Unity的程序集添加到解决方案.</p>
<p>　　2.Unity的registrations和startup逻辑是必须的.</p>
<p>　　3.Unity的解析器需要添加到OWIN startup 的上下文.</p>
<p>　　4.释放资源的逻辑必须实现.</p>
<p>使用下面的nuget包,添加OWIN.Hosting:</p>
<p><a href="http://www.nuget.org/packages/Microsoft.AspNet.WebApi.OwinSelfHost/" rel="external nofollow noreferrer">http://www.nuget.org/packages/Microsoft.AspNet.WebApi.OwinSelfHost/</a></p>
<p>Install-Package Microsoft.AspNet.WebApi.OwinSelfHost -Pre</p>
<p>使用nuget管理器添加Unity(注意不是Unity.WebApi,下面有解释)</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkxODI1OC8yMDE3MDgvOTE4MjU4LTIwMTcwODI1MTEwNTMxODA4LTE5NDY3NjYxOTYucG5n.jpg"></p>
<p>一个能被Console应用程序或Windows Service调用的开始方法是必须要具备的.这个方法决定了使用Unity创建实例.这个方法也定义了服务的url和使用OWIN配置方法开始这个服务.</p>
<pre> 1 using Owin;
 2 using System.Web.Http;
 3 using Microsoft.Owin.Hosting;
 4 using System;
 5 using System.Net.Http;
 6 using Microsoft.Practices.Unity;
 7
 8 namespace SelfHostWebApiOwin
 9 {
10     public class Startup
11     {
12         private static readonly IUnityContainer _container = UnityHelpers.GetConfiguredContainer();
13
14         public static void StartServer()
15         {
16             string baseAddress = "http://localhost:8081/";
17             var startup = _container.Resolve&lt;Startup&gt;();
18             IDisposable webApplication = WebApp.Start(baseAddress, startup.Configuration);
19
20             try
21             {
22                 Console.WriteLine("Started...");
23
24                 Console.ReadKey();
25             }
26             finally
27             {
28                 webApplication.Dispose();
29             }
30         }
31     }
32 }</pre>
<p>Configuration(IAppBuilder appBuilder)提供我们服务所有必须的信息.这里可以添加authorization, filters, http logging,和其他的OWIN客户端</p>
<pre> 1 public void Configuration(IAppBuilder appBuilder)
 2 {
 3   // Configure Web API for self-host.
 4   HttpConfiguration config = new HttpConfiguration();
 5   config.DependencyResolver = new UnityDependencyResolver(
 6       SelfHostWebApiOwin.UnityHelpers.GetConfiguredContainer());
 7
 8   config.Routes.MapHttpRoute(
 9                 name: "DefaultApi",
10                 routeTemplate: "api/{controller}/{id}",
11                 defaults: new { id = RouteParameter.Optional }
12             );
13
14   appBuilder.UseWebApi(config);
15 }</pre>
<p>在这个方法里,HttpConfiguration.DependencyResolver设置了一个UnityDependencyResolver实例.WebApi controllers使用构造函数注入必须要这么做.UnityDependencyResolver类完全相当于Unity.WebApi.UnityDependencyResolver类,我们不使用Unity.WebApi,因为这是一个自托管的OWIN应用程序.</p>
<p><a href="http://unity.codeplex.com/SourceControl/latest#Unity/Unity.WebApi/Src/UnityDependencyResolver.cs" rel="external nofollow noreferrer">http://unity.codeplex.com/SourceControl/latest#Unity/Unity.WebApi/Src/UnityDependencyResolver.cs</a></p>
<p>UnityDependencyResolver : IDependencyResolver</p>
<p>Unity的注册必须被定义.他被定义在了UnityHelper类.按照注册惯例注册实例.属性用来使用每个接口,类的生命周期注册类型可以更舒适的被定义,没有必要配置地狱.</p>
<pre> 1 using System;
 2 using System.Collections.Generic;
 3 using System.Reflection;
 4 using Microsoft.Practices.Unity;
 5 using System.Linq;
 6 using SelfHostWebApiOwin.Business.Attributes;
 7 using SelfHostWebApiOwin;
 8
 9 namespace SelfHostWebApiOwin
10 {
11     public static class UnityHelpers
12     {
13         #region Unity Container
14         private static Lazy&lt;IUnityContainer&gt; container = new Lazy&lt;IUnityContainer&gt;(() =&gt;
15         {
16             var container = new UnityContainer();
17             RegisterTypes(container);
18             return container;
19         });
20
21         public static IUnityContainer GetConfiguredContainer()
22         {
23             return container.Value;
24         }
25         #endregion
26
27         //private static readonly Type[] EmptyTypes = new Type[0];
28
29         public static IEnumerable&lt;Type&gt; GetTypesWithCustomAttribute&lt;T&gt;( Assembly[] assemblies)
30         {
31             foreach (var assembly in assemblies)
32             {
33                 foreach (Type type in assembly.GetTypes())
34                 {
35                     if (type.GetCustomAttributes(typeof(T), true).Length &gt; 0)
36                     {
37                         yield return type;
38                     }
39                 }
40             }
41         }
42
43         public static void RegisterTypes(IUnityContainer container)
44         {
45             var myAssemblies = AppDomain.CurrentDomain.GetAssemblies().Where(a =&gt; a.FullName.StartsWith("SelfHostWebApiOwin")).ToArray();
46
47             container.RegisterType(typeof(Startup));
48
49             container.RegisterTypes(
50                 UnityHelpers.GetTypesWithCustomAttribute&lt;UnityIoCContainerControlledAttribute&gt;(myAssemblies),
51                 WithMappings.FromMatchingInterface,
52                 WithName.Default,
53                 WithLifetime.ContainerControlled,
54                 null
55                 ).RegisterTypes(
56                          UnityHelpers.GetTypesWithCustomAttribute&lt;UnityIoCTransientLifetimeAttribute&gt;(myAssemblies),
57                          WithMappings.FromMatchingInterface,
58                          WithName.Default,
59                          WithLifetime.Transient);
60
61         }
62
63     }
64 }</pre>
<p>这有一个attribute的小例子.</p>
<pre> 1 using System;
 2 using System.Collections.Generic;
 3 using System.Linq;
 4 using System.Web;
 5
 6 namespace SelfHostWebApiOwin.Business.Attributes
 7 {
 8     [System.AttributeUsage(System.AttributeTargets.Class | System.AttributeTargets.Struct)]
 9     public class UnityIoCTransientLifetimeAttribute : System.Attribute
10     {
11         public double version;
12
13         public UnityIoCTransientLifetimeAttribute()
14         {
15             version = 1.0;
16         }
17     }
18 }</pre>
<p>现在可以创建业务逻辑层.在这层我只使用构造函数注入.这些类是松耦合的并且容易被测试.</p>
<pre> 1 using System;
 2 using System.Collections.Generic;
 3 using System.Linq;
 4 using System.Web;
 5 using SelfHostWebApiOwin.Business.Logging;
 6 using SelfHostWebApiOwin.Business.Attributes;
 7
 8 namespace SelfHostWebApiOwin.Business
 9 {
10     [UnityIoCTransientLifetimeAttribute]
11     public class BusinessClass : IBusinessClass
12     {
13         private IUnitOfWorkExample _unitOfWorkExample;
14
15         public BusinessClass(IUnitOfWorkExample unitOfWorkExample)
16         {
17             _unitOfWorkExample = unitOfWorkExample;
18             UnityEventLogger.Log.CreateUnityMessage("BusinessClass");
19         }
20
21         private bool _disposed = false;
22
23         public string Hello()
24         {
25             return _unitOfWorkExample.HelloFromUnitOfWorkExample();
26         }
27
28         public void Dispose()
29         {
30             _unitOfWorkExample.Dispose();
31             UnityEventLogger.Log.DisposeUnityMessage("BusinessClass");
32             if (!_disposed)
33             {
34                 _disposed = true;
35             }
36         }
37     }
38 }</pre>
<p>现在这些类可以使用构造函数注入到Controllers.</p>
<pre>1 public class ValuesController : ApiController
2     {
3         private readonly IBusinessClass _businessClass;
4         private readonly IBusinessClass2 _businessClass2;
5         public ValuesController(IBusinessClass businessClass, IBusinessClass2 businessClass2)
6         {
7             _businessClass = businessClass;
8             _businessClass2 = businessClass2;
9         }</pre>
<p>当这个示例应用程序启动的时候,<a href="http://fiddler2.com/" rel="external nofollow noreferrer">fiddler</a>可以用来连接这个api.从结果我们可以看到业务逻辑的方法被使用了并且应用程序方法被定义了.</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNy5jbmJsb2dzLmNvbS9ibG9nLzkxODI1OC8yMDE3MDgvOTE4MjU4LTIwMTcwODI1MTM1MDUwOTk2LTIyMTgwOTg0MS5wbmc=.jpg"></p>
<p>Code:&nbsp;<a href="https://github.com/damienbod/SelfHostWebApiWithOwinAndUnity" rel="external nofollow noreferrer">https://github.com/damienbod/SelfHostWebApiWithOwinAndUnity</a></p>
<p>错失了什么:</p>
<p>　　-我们没有实现适当的释放逻辑.We could do this by implementing a new LifeTime Manager (per request as implemented in Unity.MVC) with a dispose.(这句话实在不知道怎么翻译 算了)</p>
<p>　　-我们可以创建一个filter供应者.Unity.MVC也提供了一个好例子.</p>
<p>　　-我们可以使用所有里面的这些创建一个nuget包Unity.SelfHostWebApi</p>
<p>原文链接:<a href="https://damienbod.com/2013/10/01/self-host-webapi-with-owin-and-unity/" rel="external nofollow noreferrer">https://damienbod.com/2013/10/01/self-host-webapi-with-owin-and-unity/</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 10:22:18 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/console/" title="console">console</a>, <a href="https://www.biecuoliao.com/tag/span/" title="span">span</a>, <a href="https://www.biecuoliao.com/tag/src/" title="src">src</a>, <a href="https://www.biecuoliao.com/tag/fiddler/" title="fiddler">fiddler</a>, <a href="https://www.biecuoliao.com/tag/res/" title="res">res</a>, <a href="https://www.biecuoliao.com/tag/empty/" title="empty">empty</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%8a%e4%b8%8b%e6%96%87/" title="上下文">上下文</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%9a%e5%8a%a1%e9%80%bb%e8%be%91/" title="业务逻辑">业务逻辑</a>, <a href="https://www.biecuoliao.com/tag/ransient/" title="ransient">ransient</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>[翻译]自托管WebApi使用OWIN和Unity的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmYNVQM.html" rel="bookmark">Asp&period;Net WebApi 集成OWIN架构后，出现 &OpenCurlyDoubleQuote;没有 OWIN 身份验证管理器与此请求相关联&rdquo; 的解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Asp.Net WebApi 项目中开启OWIN模块之后,如果没有在OWIN的Startup类中配置认证方式,调用WebApi的相关Controller和Action就会出现如下异常: 出现错误. 没有 OWIN 身份验证管理器与此请求相关联. ExceptionType:System.InvalidOperationException StackTrace: 在 System.Web.Http.Owin.PassiveAuthenticationMessageHandler.Suppress			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JvLkP4.html" rel="bookmark">Host ASP&period;NET WebApi in Owin</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是OWIN Owin其实是微软为了解耦.Net Web app对IIS的依赖而制定的一套规范,规范定义了Web Server与Web App之间的接口,这样Web App就可以Host在所有兼容OWIN规范的Web Server了(包含控制台应用和Windows服务...).具体来说,Owin将Web app和Web Server整体划分为以下几个模块. Host  根据官方解释,Host是指server和application所依托执行的进程.主要负责应用的启动与配置. Server Se			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eAXzZ0.html" rel="bookmark">WebApi学习笔记06：使用webapi模板--仓储模式--Unity依赖注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Web项目 1.1概述 对数据操作封装使用存储模式是很常见的方式,而使用依赖注入来降低耦合度(方便创建对象,可以抛弃经典的工厂模式)…… 1.2创建项目 1.3添加模型 在Models下,添加Product.cs: namespace WebApi06.Models { public class Product { public int ID { get; set; } public string Name { get; set; } public decimal Price { get;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgyD5K3.html" rel="bookmark">webapi集成owin使用Oauth认证时能获取accee&lowbar;token仍无法登录的解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HttpConfiguration webapiConfig = new HttpConfiguration(); IIocBuilder iocBuilder = new OwinAutofacIocBuilder(services, app, webapiConfig); HelpPageConfig.Register(webapiConfig); //webapiConfig.EnsureInitialized(); app.UseCanDoo(iocBuilder); Configure			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MG8N7V0.html" rel="bookmark">基于ASP&period;NET WebAPI OWIN实现Self-Host项目实战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引用 寄宿ASP.NET Web API 不一定需要IIS 的支持,我们可以采用Self Host 的方式使用任意类型的应用程序(控制台.Windows Forms 应用.WPF 应用甚至是Windows Service)作为宿主. 一.摘要 本期同样带给大家分享的是阿笨在实际工作中遇到的真实业务场景,请跟随阿笨的视角去如何实现采用微软的ASP.NET OWIN技术承载WebAPI服务,如果您对本期的教程内容感兴趣,那么请允许让阿笨带着大家一起学习吧! 废话不多说,直接上干货,我们不生产干货,我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MG8BEG0.html" rel="bookmark">OWIN 自宿主模式WebApi项目，WebApi层作为单独类库供OWIN调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么我们需要OWIN 过去,IIS作为.NET开发者来说是最常用的Web Server(没有之一),源于微软产品的紧耦合关系,我们不得不将Website.Web Application.Web API等部署在IIS上,事实上在2010年前并没有什么不妥,但随着近些年来Web的发展,特别是移动互联网飞速发展,IIS作为Web Server已经暴露出他的不足了.主要体现在两个方面,ASP.NET (System.Web)紧耦合IIS,IIS紧耦合OS,这就意味着,我们的Web Framework必			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rBPZb3.html" rel="bookmark">构建ASP&period;NET MVC5&plus;EF6&plus;EasyUI 1&period;4&period;3&plus;Unity4&period;x注入的后台管理系统（64）-WebApi与Unity注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言: 有时候我们系统需要开放数据给手机App端或其他移动设备,不得不说Asp.net WebApi是目前首选 本节记录Asp.net MVC WebApi怎么利用Unity注入.系列开头已经讲解了普通的Asp.net MVC如何用Unity注入容器 不明白什么是IOC,DI,控制反转的自行百度补脑,否则无法阅读本文 其实这也是一次技术上的记录,因为找遍大百度居然没有可以用的利用Unity注入的WebApi!感谢随风朋友的提醒.才能完成本节的指导 为了更好的理解,请下载代码 示例代码下载   h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mo5ZDP3.html" rel="bookmark">Unity常见面试题大全</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.       [C#语言基础]请简述拆箱和装箱. 答: 装箱操作: 值类型隐式转换为object类型或由此值类型实现的任何接口类型的过程. 1.在堆中开辟内存空间. 2.将值类型的数据复制到堆中. 3.返回堆中新分配对象的地址. 拆箱操作: object类型显示转换为值类型或从接口类型到实现该接口值类型的过程. 1.判断给定类型是否是装箱时的类型. 2.返回已装箱实例中属于原值类型字段的地址. 2.        [.NET(C#)] attribute,property,markup,ta			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLJGxe3.html" rel="bookmark">从System&period;Web&period;Http&period;Owin的HttpMessageHandlerAdapter看适配器模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				.mytitle { background: #2B6695; color: white; font-family: &quot;微软雅黑&quot;, &quot;宋体&quot;, &quot;黑体&quot;, Arial; font-size: 18px; font-weight: bold; height: 25px; line-height: 25px; margin: 15px 0 !important; padding: 5px 0 5px 20px; width: 97% } .arti			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/D3OALrM.html" rel="bookmark" class="title">Unity预计算全局光照的学习&lpar;速度优化&comma;LightProbe&comma;LPPV&rpar;</a>
					<div>
						1.基本参数与使用 1.1 常规介绍 使用预计算光照需要在Window/Lighting面板下找到预计算光照选项,保持勾选预计算光照并保证场景中有一个光照静态的物体 此时在编辑器内构建后,预计算光照开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n3ZB1d3.html" rel="bookmark" class="title">20161124</a>
					<div>
						今天学习了一些函数,以及编写了一些简单的函数. 笔记: js中一个=代表赋值,运算顺序从右往左 数学运算符:+ - * / 求余% var a = 1 b = a++ 是先赋值,再运算   b = 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWwREyM.html" rel="bookmark" class="title">C（3）</a>
					<div>
						多次运用循环,条件语句,定义数组,排序 旅行团需要租帆船进行冒险活动,一条帆船最多乘坐两人,且乘客的总重量不能超过帆船的最大载重.为尽可能的减少活动花销,你要找出最少帆船条数.现写一个程序,输入帆船的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vvXJZ3.html" rel="bookmark" class="title">javascript性能优化-repaint和reflow</a>
					<div>
						repaint(重绘) ,repaint发生更改时,元素的外观被改变,且在没有改变布局的情况下发生,如改变outline,visibility,background color,不会影响到dom结构渲 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDXQyM.html" rel="bookmark" class="title">获取 AlertDialog自定义的布局 的控件</a>
					<div>
						AlertDialog自定义的布局 效果图: 创建dialog方法的代码如下: 1 LayoutInflater inflater = getLayoutInflater(); 2 View layo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vvLdZ3.html" rel="bookmark" class="title">PAT  1021&period; Deepest Root &lpar;25&rpar;</a>
					<div>
						1021. Deepest Root (25) A graph which is connected and acyclic can be considered a tree. The height  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVY7dk4.html" rel="bookmark" class="title">Perl脚本访问Greenplum数据库安装指导</a>
					<div>
						安装前准备 (1)操作系统(系统上面要安装一些必备的开发工具(比如gcc等)) linux-82:/home/PlODBC # cat/etc/SuSE-release SUSE Linux Ente ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Dr8z4.html" rel="bookmark" class="title">JAVA笔记10&lowbar;&lowbar;Math类、Random类、Arrays类&sol;日期操作类&sol;对象比较器&sol;</a>
					<div>
						/** * Math类.Random类.Arrays类:具体查JAVA手册...... */ public class Main { public static void main(String[]  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5oJo3.html" rel="bookmark" class="title">Android 使用xml和java混合编写ui</a>
					<div>
						以一个简单的图片浏览器实例说明 新建工程后: 在activit_main.xml中添加代码: &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p5xxyM.html" rel="bookmark" class="title">我的2015年的任务</a>
					<div>
						1. 精通c#在clr中的运行机制[没有完成] 2 .精通oralce数据库[没有完成] 3 .学习java的开发.[没有完成] 4 .精通业务系统,[资金系统.报账中心系统.总账系统.成本管理.应收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylWJE4.html" rel="bookmark" class="title">C&num; 对Excel操作与分析</a>
					<div>
						今天帮现在饿公司写个工具,要动态读excel上的ip地址与端口号,来更改IE的代理地址,由于好久没写Excel的操作了,只能查阅以前的项目,总结一下: 首先我们要引用我们的com接口的excelMic ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qEQ1W3.html" rel="bookmark" class="title">微软unity 注入mvc</a>
					<div>
						首先获取开源unity ,引用, 新建UnityDependencyResolver 继承IDependencyResolver,代码如下: public class UnityDependencyR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AZWWvM.html" rel="bookmark" class="title">Java 类的实例变量初始化的过程 静态块、非静态块、构造函数的加载顺序</a>
					<div>
						Java 类的实例变量初始化的过程 静态块.非静态块.构造函数的加载顺序 先看一道Java面试题: 1 public class Baset { 2 private String baseName = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JyZD93.html" rel="bookmark" class="title">一次没有最后期限的编程之旅</a>
					<div>
						今年上半年,是我工作以来最繁忙的六个月,总之遇到了最艰难的教程.最冗长的文档.最繁琐的代码以及最窘迫的合作,最终的极度疲劳成了压垮了我的最后一根稻草. 那年杭州,接连40摄氏度以上的连续高温,忽然一天 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022Raa0.html" rel="bookmark" class="title">MySQLdump常用命令</a>
					<div>
						MySQLdump常用mysqldump -u root -p --databases 数据库1 数据库2 &gt; xxx.sql 还原:系统命令行: MySQL -uroot -p123456 & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jeE1gM.html" rel="bookmark" class="title">常用邮件协议</a>
					<div>
						SMTP SMTP 的全称是“Simple Mail Transfer Protocol”,即简单邮件传输协议.它是一组用于从源地址到目的地址传输邮件的规范,通过它来控制邮件的中转方式.SMTP 帮助 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPZNV4.html" rel="bookmark" class="title">segment-实现SVG路径描边绘制与动画的轻量库</a>
					<div>
						今天来一起了解一个实现SVG路径描边绘制与动画的轻量级类库segment,我们从轻松上手.使用详解.资源和案例.源码解读等几个方面进行介绍. 1. 轻松上手 html方面添加segment,定义pat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZpAOJM.html" rel="bookmark" class="title">Linux指令篇&colon;工作行程资讯与管理--renice</a>
					<div>
						名称:renice 使用权限:所有使用者 使用方式:renice priority [[-p] pid ...] [[-g] pgrp ...] [[-u] user ...] 说明:重新指定一个或多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzBAvAM.html" rel="bookmark" class="title">汉企0908下午课</a>
					<div>
						表单元素: ①②③④⑤⑥⑦★ 一.&lt;from&gt; 1. 代表表单 2 . action:提交为哪个页面 method:①  get :显示提交,由长度限制 ②  post: 隐藏提交 二.文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZpqqZM.html" rel="bookmark" class="title">Servlet支持上传多张图片</a>
					<div>
						首先前端的表单是这个形式: &lt;form  target=&quot;_self&quot; method=&quot;post&quot; action=&quot;fileUploadMult ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
